// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.



/** \file GNUPlotWriter.h */

#ifndef AMDIS_GNUPLOTWRITER_H
#define AMDIS_GNUPLOTWRITER_H

#include <vector>
#include <string>
#include "FileWriter.h"
#include "AMDiS_fwd.h"

namespace AMDiS {

  ///
  class GNUPlotWriter : public FileWriterInterface
  {
  public:
    ///
    GNUPlotWriter(std::string filename,
		  FiniteElemSpace *feSpace,
		  std::vector<DOFVector<double>*> &dofVectors);

    ///
    virtual ~GNUPlotWriter() {}

    ///
    virtual void writeFiles(AdaptInfo *adaptInfo, bool force);

  protected:
    /// Contains the mesh
    FiniteElemSpace *feSpace_;

    /// vector of dof vectors to write
    std::vector<DOFVector<double>*> dofVectors_;

    /// file name
    std::string filename_;
  };

}

#endif // AMDIS_VALUEWRITER_H
